"use strict";

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _jquery = require("jquery");

var _jquery2 = _interopRequireDefault(_jquery);

var _qwebchannel = require("../qwebchannel");

var _yylibUi = require("yylib-ui");

var _antd = require("antd");

var _attachaction = require("../attachaction");

var _BaseHost = require("../../BaseHost");

var _BaseHost2 = _interopRequireDefault(_BaseHost);

var _ajax = require("yylib-utils/ajax");

var _ajax2 = _interopRequireDefault(_ajax);

require("../mgrNewDialog.less");

require("../font/iconfont.css");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Dragger = _antd.Upload.Dragger;
var confirm = _antd.Modal.confirm;
var field = _yylibUi.YYClass.field,
    PropTypes = _yylibUi.YYClass.PropTypes;
// 定义组件配置信息

var uiMeta = {
  name: "AttachMgrModalNew",
  fields: [
  //field 参数列表：字段属性名|属性默认值|属性类型|是否必填|属性描述
  //------------附件管理按钮配置------------//
  field("type", "error", PropTypes.oneOf(["primary", "success", "info", "warning", "error", ""]), false, "设置按钮类型，可选值为 primary|success|info|warning|error 或者不设"), field("buttonText", "附件管理", PropTypes.string, false, "设置按钮的文本"), field("icon", "upload", PropTypes.string, false, "设置按钮的图标类型"), field("visible", true, PropTypes.bool, false, "设置按钮是否显示"), field("disabled", false, PropTypes.bool, false, "设置按钮是否禁用"), field("ghost", true, PropTypes.bool, false, "设置按钮为不填充形态")]
};
var imgPath, deletePath;
var AttachMgrModalNew = _yylibUi.YYClass.create({
  uiMeta: uiMeta,
  displayName: "AttachMgrModalNew",
  // 初始化数据等同于state
  getInitialState: function getInitialState() {
    return {
      _urlUpload: _BaseHost2.default,
      _urlDownLoad: _BaseHost2.default,
      userId: "",
      userName: "",
      sourceId: "",
      billType: "",
      sourceType: "",
      billState: 0,
      visible: false,
      visibleHM: false,
      isToolBar: true,
      visiblePreview: false,
      setTimeoutFlag: false,
      imgVideo: "",
      videoUrl: "",
      deviceInfo: "",
      previeTitle: "",
      imgRoate: 0,
      imgHeight: 60,
      openSocketNum: 0,
      infoNum: 0,
      timeOutNum: 0,
      previewIndex: 0,
      deletedLength: 0,
      mouseDownNum: 0,
      imgPathArray: [], //base64路径，拍摄后显示本地图片
      deletePathArray: [], //删除的绝对路径标注
      deletedArray: [], //确认删除的数组
      uploadArray: [],
      uploadFileList: [],
      getUploadList: [],
      imageTypes: ["png", "jpeg", "jpg", "ico", "gif", "bip", "tiff", "tga", "eps"]
    };
  },
  // 打开高拍仪模态框
  showModalHM: function showModalHM() {
    var _this2 = this;

    var num = this.state.openSocketNum;
    num++;
    this.setState({
      visibleHM: true,
      openSocketNum: num
    }, function () {
      num <= 1 ? _this2.openSocket() : dialog.html_loaded("one");
    });
  },
  // 打开第一个模态框
  handleShowModal: function handleShowModal() {
    this.setState({
      visible: !this.state.visible
    });
  },
  // 隐藏第一个模态框
  hideModal: function hideModal() {
    this.setState({
      visible: false
    });
  },
  // 隐藏高拍仪模态框
  hideModalHM: function hideModalHM() {
    var imgPathArray = this.state.imgPathArray;

    var _this = this;
    if (imgPathArray.length > 0) {
      confirm({
        title: "关闭后未上传的照片会消失，确定要关闭吗？",
        content: false,
        onOk: function onOk() {
          _this.setState({
            visibleHM: false,
            setTimeoutFlag: true,
            deviceInfo: "",
            imgVideo: "",
            imgPathArray: [], //base64路径，拍摄后显示本地图片
            deletePathArray: [], //删除的绝对路径标注
            deletedArray: [], //确认删除的数组
            uploadArray: [],
            deletedLength: 0
          }, function () {
            if (!window.dialog || !dialog) return;
            dialog.get_actionType("closePriVideo");
            imgPath = "";
            deletePath = "";
          });
        }
      });
      return;
    }
    this.setState({
      visibleHM: false,
      setTimeoutFlag: true,
      deviceInfo: "",
      imgVideo: "",
      imgPathArray: [], //base64路径，拍摄后显示本地图片
      deletePathArray: [], //删除的绝对路径标注
      deletedArray: [], //确认删除的数组
      uploadArray: [],
      deletedLength: 0
    }, function () {
      if (!window.dialog || !dialog) return;
      dialog.get_actionType("closePriVideo");
      imgPath = "";
      deletePath = "";
    });
  },
  // 隐藏预览模态框
  hideModalPreview: function hideModalPreview() {
    this.setState({
      visiblePreview: false
    });
  },
  // 获取文件后缀名
  fileSuffix: function fileSuffix(fileName) {
    var first = fileName.lastIndexOf(".");
    var namelength = fileName.length;
    var filesuffix = fileName.substring(first + 1, namelength);
    return filesuffix;
  },
  // base64转blob
  base64ToBlob: function base64ToBlob(base64Data) {
    var arr = base64Data.split(","),
        fileType = arr[0].match(/:(.*?);/)[1],
        bstr = atob(arr[1]),
        l = bstr.length,
        u8Arr = new Uint8Array(l);

    while (l--) {
      u8Arr[l] = bstr.charCodeAt(l);
    }
    return new Blob([u8Arr], {
      type: fileType
    });
  },
  // blob转file
  blobToFile: function blobToFile(newBlob, fileName) {
    newBlob.lastModifiedDate = new Date();
    newBlob.name = fileName;
    return newBlob;
  },
  // 打开webSocket连接高拍仪
  openSocket: function openSocket() {
    var _this = this;
    var _state = this.state,
        setTimeoutFlag = _state.setTimeoutFlag,
        infoNum = _state.infoNum;

    var baseUrl = "ws://127.0.0.1:12345";
    var socket = new WebSocket(baseUrl);
    var newInfoNum = infoNum;
    socket.onerror = function (error) {
      if (error.type === "error") {
        newInfoNum += 1;
        _this.setState({
          infoNum: newInfoNum
        }, function () {
          if (_this.state.infoNum <= 1) {
            _yylibUi.YYMessage.error("请检查设备驱动,连接后刷新页面尝试");
          }
        });
        if (!setTimeoutFlag) {
          setTimeout(function () {
            _this.openSocket();
          }, 2500);
        }
      }
    };
    socket.onopen = function () {
      new _qwebchannel.QWebChannel(socket, function (channel) {
        window.dialog = channel.objects.dialog;
        //网页关闭函数
        window.onbeforeunload = function () {
          //发送关闭信号
          dialog.get_actionType("closeSignal");
          //关闭socket
          socket.close();
        };
        window.onunload = function () {
          //发送关闭信号
          dialog.get_actionType("closeSignal");
          //关闭socket
          socket.close();
        };
        //服务器返回消息
        dialog.sendPrintInfo.connect(function (message) {
          //获取文件base64返回值
          if (message.indexOf("fileBase64:") >= 0) {
            var value = message.substr(11);
            alert(value);
            return;
          }
          if (message.indexOf("No equipment found!") >= 0) {
            _yylibUi.YYMessage.error("没有设备,请连接设备");
          }
          // 设备信息
          if (message.indexOf("priDevName:") >= 0) {
            message = message.substr(11);
            if (message.indexOf("USB") < 0) {
              _this.setState({
                deviceInfo: message
              });
            }
          }
          if (message.indexOf("savePhoto_success:") >= 0) {
            deletePath = message.substr(18);
            _this.addImgDiv();
          }
        });
        //接收图片流用来展示，多个，较小的base64数据
        dialog.send_priImgData.connect(function (message) {
          _this.setState({
            imgVideo: "data:image/jpg;base64," + message
          });
          imgPath = "data:image/jpg;base64," + message;
        });
        //网页加载完成信号
        dialog.html_loaded("one");
      });
    };
  },
  // 添加拍照缩略图
  addImgDiv: function addImgDiv() {
    this.setState({
      imgPathArray: this.state.imgPathArray.concat(imgPath),
      uploadArray: this.state.uploadArray.concat(imgPath),
      deletePathArray: this.state.deletePathArray.concat(deletePath),
      deletedArray: this.state.deletedArray.concat(deletePath),
      deletedLength: this.state.deletedLength + 1
    });
  },
  // 拍照
  onClickBtn: function onClickBtn() {
    var timeOutNum = this.state.timeOutNum;

    var _this = this;
    var num = timeOutNum;
    //防止重复点击拍照
    if (num === 0) {
      num = 1;
      this.setState({
        timeOutNum: num
      });
      dialog.photoBtnClicked("primaryDev_");
      dialog.get_actionType("savePhotoPriDev");
      setTimeout(function () {
        _this.setState({
          timeOutNum: 0
        });
      }, 2000);
    }
  },
  // 选中图片
  handleCheckbox: function handleCheckbox(e, name, uploadName) {
    var _state2 = this.state,
        deletedArray = _state2.deletedArray,
        uploadArray = _state2.uploadArray,
        deletedLength = _state2.deletedLength;

    var nameNew = deletedArray;
    var newUploadName = uploadArray;
    if (e.target.checked === true) {
      nameNew = deletedArray.concat(name);
      newUploadName = uploadArray.concat(uploadName);
      this.setState({
        deletedArray: nameNew,
        uploadArray: newUploadName,
        deletedLength: deletedLength + 1
      });
    } else {
      var index = deletedArray.indexOf(name);
      nameNew.splice(index, 1);
      newUploadName.splice(index, 1);
      this.setState({
        deletedArray: nameNew,
        uploadArray: newUploadName,
        deletedLength: deletedLength - 1
      });
    }
  },
  // 删除本地照片
  deleteHandleFile: function deleteHandleFile() {
    var _state3 = this.state,
        deletedArray = _state3.deletedArray,
        imgPathArray = _state3.imgPathArray,
        deletePathArray = _state3.deletePathArray;

    var newPathArr = imgPathArray,
        newDelPathArr = deletePathArray;
    if (!deletedArray.length) {
      _yylibUi.YYMessage.error("没有需要删除的照片");
      return;
    }
    for (var i = 0; i < deletedArray.length; i++) {
      var index = deletePathArray.indexOf(deletedArray[i]);
      newPathArr.splice(index, 1);
      newDelPathArr.splice(index, 1);
      dialog.get_functionTypes("deleteFile", deletedArray[i], "", "");
    }
    this.setState({
      imgPathArray: newPathArr,
      deletePathArray: newDelPathArr,
      deletedArray: [],
      uploadArray: [],
      deletedLength: 0
    });
  },
  //上传按钮
  handleUpload: function handleUpload() {
    var _this3 = this;

    var _state4 = this.state,
        uploadArray = _state4.uploadArray,
        deletedArray = _state4.deletedArray,
        userId = _state4.userId,
        userName = _state4.userName,
        sourceId = _state4.sourceId,
        billType = _state4.billType,
        sourceType = _state4.sourceType,
        _urlUpload = _state4._urlUpload;

    if (!uploadArray.length) {
      _yylibUi.YYMessage.error("请选择要上传的文件");
      return;
    }
    var fileNames = deletedArray.map(function (pathItem) {
      var slices = pathItem.split("\\");
      return slices[slices.length - 1];
    });
    var blobs = uploadArray.map(function (base64Item) {
      return _this3.base64ToBlob(base64Item);
    });
    var files = blobs.map(function (blobsItem, index) {
      return _this3.blobToFile(blobsItem, fileNames[index]);
    });

    var uploadRequest = function uploadRequest(len, index) {
      if (index >= len) {
        _yylibUi.YYMessage.success("上传成功");
        _this3.deleteHandleFile();
        _this3.getUploadListFn();
        _this3.setState({
          uploadArray: []
        });
        return;
      }
      var formData = new FormData();
      formData.append("sourceId", sourceId);
      formData.append("billType", billType);
      formData.append("sourceType", sourceType);
      formData.append("userId", userId);
      formData.append("userName", userName);
      formData.append("file", files[index], fileNames[index]);
      var xhr = new XMLHttpRequest();
      xhr.onreadystatechange = function () {
        if (xhr.readyState == 4) {
          if (xhr.status == 200) {
            uploadRequest(len, ++index);
          } else {}
        }
      };
      xhr.open("post", _urlUpload + "/icop-file/file/upload2", true);
      xhr.send(formData);
    };
    uploadRequest(files.length, 0);
  },
  // 图片预览
  handlePreview: function handlePreview(file) {
    this.setState({
      previewImage: file.url || file.thumbUrl,
      previewVisible: true
    });
  },
  // 展示预览窗
  handlePreviewShowModal: function handlePreviewShowModal(index, name) {
    var _state5 = this.state,
        getUploadList = _state5.getUploadList,
        _urlUpload = _state5._urlUpload,
        imageTypes = _state5.imageTypes;

    if (!getUploadList) return;
    var fileName = this.fileSuffix(name);
    if (imageTypes.indexOf(fileName) > -1) {
      this.setState({
        visiblePreview: true,
        isToolBar: true,
        previewIndex: index,
        imgRoate: 0,
        imgHeight: 60
      });
    } else {
      var isChrome = this.browserClass();
      var _url = "";
      var fileType = this.fileSuffix(getUploadList[index].fileName);
      if (isChrome === "Chrome" && (fileType === "pdf" || fileType === "PDF")) {
        _url = _urlUpload + "/" + getUploadList[index].filePath;
      } else {
        _url = (0, _attachaction.handleUrl)("https://cc.yonyouccs.com/icop-file/onlinePreview?url=" + _urlUpload + "/" + getUploadList[index].filePath + "?filename=" + getUploadList[index].fileName);
      };
      var previewWin = window.open(_url);
      if (!previewWin) {
        _yylibUi.YYMessage.error("预览窗口打开失败，请检查浏览器是否阻止弹出窗口！");
      };
    }
  },
  browserClass: function browserClass() {
    var userAgent = navigator.userAgent;
    var isOpera = userAgent.indexOf("Opera") > -1;
    var isIE = userAgent.indexOf("compatible") > -1 && userAgent.indexOf("MSIE") > -1 && !isOpera;
    var isEdge = userAgent.indexOf("Edge") > -1;
    var isFF = userAgent.indexOf("Firefox") > -1;
    var isSafari = userAgent.indexOf("Safari") > -1 && userAgent.indexOf("Chrome") == -1;
    var isChrome = userAgent.indexOf("Chrome") > -1 && userAgent.indexOf("Safari") > -1;

    if (isIE) {
      var reIE = new RegExp("MSIE (\\d+\\.\\d+);");
      reIE.test(userAgent);
      var fIEVersion = parseFloat(RegExp["$1"]);
      if (fIEVersion == 7) {
        return "IE7";
      } else if (fIEVersion == 8) {
        return "IE8";
      } else if (fIEVersion == 9) {
        return "IE9";
      } else if (fIEVersion == 10) {
        return "IE10";
      } else if (fIEVersion == 11) {
        return "IE11";
      } else {
        return "0";
      } //IE版本过低
      return "IE";
    }
    if (isOpera) {
      return "Opera";
    }
    if (isEdge) {
      return "Edge";
    }
    if (isFF) {
      return "FF";
    }
    if (isSafari) {
      return "Safari";
    }
    if (isChrome) {
      return "Chrome";
    }
  },
  //预览附件（文档）
  handleClickPreview: function handleClickPreview(params) {
    var _urlUpload = this.state._urlUpload;

    var isChrome = this.browserClass();
    var fileType = this.fileSuffix(params.fileName);
    var _url = "";
    if (isChrome === "Chrome" && (fileType === "pdf" || fileType === "PDF")) {
      _url = _urlUpload + "/" + params.filePath;
    } else {
      _url = (0, _attachaction.handleUrl)("https://cc.yonyouccs.com/icop-file/onlinePreview?url=" + _urlUpload + "/" + params.filePath + "?filename=" + params.fileName);
    };
    var previewWin = window.open(_url);
    if (!previewWin) {
      _yylibUi.YYMessage.error("预览窗口打开失败，请检查浏览器是否阻止弹出窗口！");
    };
  },
  // 预览上一个
  handlePrePrve: function handlePrePrve() {
    var _this4 = this;

    var _state6 = this.state,
        getUploadList = _state6.getUploadList,
        previewIndex = _state6.previewIndex;

    var _index = previewIndex;
    _index <= 0 ? _index = getUploadList.length - 1 : _index--;
    this.setState({
      previewIndex: _index,
      imgRoate: 0
    }, function () {
      if ((0, _jquery2.default)(".activeted").find(".imgParent").length === 0) {
        _this4.setState({
          isToolBar: true,
          imgHeight: 60
        });
      } else {
        _this4.setState({
          isToolBar: false
        });
      }
    });
  },
  // 预览下一个
  handlePreNext: function handlePreNext() {
    var _this5 = this;

    var _state7 = this.state,
        getUploadList = _state7.getUploadList,
        previewIndex = _state7.previewIndex;

    var _index = previewIndex;
    _index + 1 >= getUploadList.length ? _index = 0 : _index++;
    this.setState({
      previewIndex: _index,
      imgRoate: 0
    }, function () {
      if ((0, _jquery2.default)(".activeted").find(".imgParent").length === 0) {
        _this5.setState({
          isToolBar: true,
          imgHeight: 60
        });
      } else {
        _this5.setState({
          isToolBar: false
        });
      }
    });
  },
  // 鼠标按下
  handleMouseDown: function handleMouseDown(e) {
    e.preventDefault();
    this.setState({
      mouseDownNum: e.pageX
    });
  },
  // 鼠标抬起
  handleMouseUp: function handleMouseUp(e) {
    var mouseDownNum = this.state.mouseDownNum;

    var fileNum = Math.abs(mouseDownNum - e.pageX);
    if (fileNum < 35) {
      //数值越大拖动距离越大
      return;
    }
    mouseDownNum < e.pageX ? this.handlePrePrve() : this.handlePreNext();
  },
  // 禁止图片默认拖拽事件
  stopePreventDefault: function stopePreventDefault(e) {
    e.preventDefault();
  },
  // 还原
  handleClickRevert: function handleClickRevert() {
    this.setState({
      imgHeight: 60
    });
  },
  // 放大
  handleClickPlus: function handleClickPlus() {
    var imgHeight = this.state.imgHeight;

    var _height = parseInt(imgHeight * 1.2);
    this.setState({
      imgHeight: _height
    });
  },
  // 缩小
  handleClickMinus: function handleClickMinus() {
    var imgHeight = this.state.imgHeight;

    var _height = parseInt(imgHeight / 1.2);
    if (imgHeight <= 20) {
      _yylibUi.YYMessage.error("已经最小了");
      return;
    }
    this.setState({
      imgHeight: _height
    });
  },
  // 旋转
  handleClickRotate: function handleClickRotate(params) {
    var imgRotateNum = this.state.imgRoate;
    if (params === 0) {
      imgRotateNum = imgRotateNum <= 270 ? imgRotateNum -= 90 : 0;
    } else {
      imgRotateNum = imgRotateNum >= 270 ? 0 : imgRotateNum += 90;
    }
    this.setState({
      imgRoate: imgRotateNum
    });
  },
  // 获取上传的列表
  getUploadListFn: function getUploadListFn() {
    var _this6 = this;

    var _state8 = this.state,
        _urlUpload = _state8._urlUpload,
        sourceId = _state8.sourceId,
        billType = _state8.billType,
        sourceType = _state8.sourceType;

    _ajax2.default.postJSON(_urlUpload + "/icop-file/file/list?id=" + sourceId + "&billType=" + billType + "&type=" + sourceType, "", function (res) {
      var data = res.backData;
      _this6.setState({
        getUploadList: data
      });
    });
  },
  //格式化文件大小
  formatFileSize: function formatFileSize(bytes) {
    var decimalPoint = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 2;

    if (bytes == 0) return "0 Bytes";
    var k = 1000,
        sizes = ["Bytes", "KB", "MB", "GB", "TB", "PB", "EB", "ZB", "YB"],
        i = Math.floor(Math.log(bytes) / Math.log(k));
    return parseFloat((bytes / Math.pow(k, i)).toFixed(decimalPoint)) + " " + sizes[i];
  },
  //格式化Unix时间戳
  formatUnixDate: function formatUnixDate(unix) {
    var date = new Date(unix);
    var FullYear = date.getFullYear();
    var month = date.getMonth() + 1 < 10 ? "0" + (date.getMonth() + 1) : date.getMonth() + 1;
    var day = date.getDate() < 10 ? "0" + date.getDate() : date.getDate();
    return FullYear + "-" + month + "-" + day;
  },
  //附件列表鼠标移入
  handleMouseOver: function handleMouseOver(index) {
    this.refs['domText' + index].innerText = "点击此下载文件，点击图片进行在线预览！";
  },
  //附件列表鼠标移出
  handleMouseOut: function handleMouseOut(index, fileName) {
    this.refs['domText' + index].innerText = fileName;
  },
  // 删除附件
  handleDeleteMgr: function handleDeleteMgr(params, types) {
    var _this7 = this;

    var _state9 = this.state,
        _urlUpload = _state9._urlUpload,
        sourceId = _state9.sourceId,
        billType = _state9.billType,
        sourceType = _state9.sourceType,
        previewIndex = _state9.previewIndex,
        getUploadList = _state9.getUploadList,
        imageTypes = _state9.imageTypes;

    var _url = _urlUpload + "/icop-file/file/del?id=" + sourceId + "&billType=" + billType + "&sourceType=" + sourceType + "&attachIds=" + ("" + params);
    _ajax2.default.postJSON(_url, "", function (res) {
      if (res.success) {
        _yylibUi.YYMessage.success("删除成功");
        if (types === 1) {
          if (getUploadList.length <= 1) {
            _this7.setState({
              visiblePreview: false,
              getUploadList: []
            });
            return;
          }
          var _index = previewIndex;
          var newName = _this7.fileSuffix(getUploadList[_index === 0 ? 1 : _index - 1].fileName);
          _index === 0 ? 1 : _index--;
          if (imageTypes.indexOf(newName) > -1) {
            _this7.setState({
              previewIndex: _index,
              isToolBar: true
            }, function () {
              _this7.getUploadListFn();
            });
          } else {
            _this7.setState({
              previewIndex: _index,
              isToolBar: false
            }, function () {
              _this7.getUploadListFn();
            });
          }
        } else {
          _this7.getUploadListFn();
        }
      } else {
        _yylibUi.YYMessage.error("删除失败" + ("" + res.error));
      }
    });
  },
  componentDidMount: function componentDidMount() {
    var isPostParams = this.props.postParams;
    if (isPostParams) {
      var _res = this.props.postParams();
      if (!_res.myParams) {
        return;
      }
      if (_res.myParams.sourceType === undefined) {
        return;
      }
      var userId = _res.myParams.creatorId;
      var userName = _res.myParams.creatorName;
      var sourceId = _res.myParams.id;
      var billType = _res.myParams.billType;
      var billState = _res.myParams.billState;
      var sourceType = _res.myParams.sourceType || "102345678";
      if (sourceId != this.state.sourceId) {
        this.setState({
          userId: userId,
          userName: userName,
          sourceId: sourceId,
          billType: billType,
          sourceType: sourceType,
          billState: billState
        }, function () {
          this.getUploadListFn();
        });
      }
    }
  },
  componentWillReceiveProps: function componentWillReceiveProps(nextProps) {
    if (nextProps.postParams) {
      var _res = nextProps.postParams();
      if (!_res.myParams) {
        return;
      }
      var userId = _res.myParams.creatorId;
      var userName = _res.myParams.creatorName;
      var sourceId = _res.myParams.id;
      var billType = _res.myParams.billType;
      var billState = _res.myParams.billState;
      var sourceType = _res.myParams.sourceType || "102345678";
      if (sourceId != this.state.sourceId) {
        this.setState({
          userId: userId,
          userName: userName,
          sourceId: sourceId,
          billType: billType,
          sourceType: sourceType,
          billState: billState
        }, function () {
          this.getUploadListFn();
        });
      } else {
        if (billState != this.state.billState) {
          this.setState({
            billState: billState
          }, function () {
            this.getUploadListFn();
          });
        };
      }
    }
  },
  render: function render() {
    var _this8 = this;

    var _props = this.props,
        type = _props.type,
        icon = _props.icon,
        disabled = _props.disabled,
        ghost = _props.ghost,
        buttonText = _props.buttonText;
    var _state10 = this.state,
        _urlUpload = _state10._urlUpload,
        imgVideo = _state10.imgVideo,
        imgPathArray = _state10.imgPathArray,
        deletePathArray = _state10.deletePathArray,
        deletedLength = _state10.deletedLength,
        getUploadList = _state10.getUploadList,
        deviceInfo = _state10.deviceInfo,
        sourceId = _state10.sourceId,
        billType = _state10.billType,
        sourceType = _state10.sourceType,
        billState = _state10.billState,
        userId = _state10.userId,
        userName = _state10.userName,
        previewIndex = _state10.previewIndex,
        imgRoate = _state10.imgRoate,
        imgHeight = _state10.imgHeight,
        isToolBar = _state10.isToolBar,
        visiblePreview = _state10.visiblePreview,
        imageTypes = _state10.imageTypes;

    var dataNull = getUploadList ? getUploadList.length : 0;
    var titleID = "";
    if (dataNull === 1) {
      titleID = "mgrNums_1";
    } else if (dataNull === 11) {
      titleID = "mgrNums_11";
    } else if (dataNull > 9 && dataNull != 11) {
      titleID = "mgrNums";
    } else {
      titleID = "";
    }
    var _this = this;
    var draggerProps = {
      name: "file",
      listType: "picture",
      showUploadList: false,
      action: _urlUpload + "/icop-file/file/upload2",
      data: {
        sourceId: sourceId,
        billType: billType, //业务单据类型
        sourceType: sourceType, //业务单据文件细分类别标识
        userId: userId,
        userName: userName
      },
      beforeUpload: function beforeUpload(file) {
        // let first = file.name.lastIndexOf(".");
        // let namelength = file.name.length;
        // let regexName = file.name.substring(first + 1, namelength);
        // const isUploadNameRegex =
        //   regexName === "jpg" ||
        //   regexName === "jpeg" ||
        //   regexName === "png" ||
        //   regexName === "gif" ||
        //   regexName === "pdf" ||
        //   regexName === "PDF" ||
        //   regexName === "doc" ||
        //   regexName === "docx" ||
        //   regexName === "ppt" ||
        //   regexName === "pptx" ||
        //   regexName === "xls" ||
        //   regexName === "xlsx" ||
        //   regexName === "rtf" ||
        //   regexName === "txt" ||
        //   regexName === "zip";

        // if (!isUploadNameRegex) {
        //   YYMessage.error("此文件不支持上传");
        // }
        var isLimit = file.size / 1024 / 1024 < 200;
        if (!isLimit) {
          _yylibUi.YYMessage.error('上传文件大小超出限制');
        };
        return isLimit;
      },
      onChange: function onChange(info) {
        var _info$file = info.file,
            status = _info$file.status,
            response = _info$file.response;

        if (response) {
          if (response.success === true) {
            if (status === "done") {
              var infoList = info.fileList;
              for (var i = 0; i < infoList.length; i++) {
                if (infoList[i].type !== "image/png" && infoList[i].type !== "image/x-icon" && infoList[i].type !== "image/jpeg" && infoList[i].type !== "image/gif") {
                  infoList[i].thumbUrl = [require("./file.png")];
                }
              }
              _yylibUi.YYMessage.success(info.file.name + "\u4E0A\u4F20\u6210\u529F");
              _this.setState({
                uploadFileList: infoList
              }, function () {
                _this.getUploadListFn();
              });
            } else if (status === "error") {
              _yylibUi.YYMessage.error(info.file.name + "\u4E0A\u4F20\u5931\u8D25");
            }
          } else {
            _yylibUi.YYMessage.error(info.file.name + "\u4E0A\u4F20\u5931\u8D25");
          }
        }
      }
    };
    return _react2.default.createElement(
      "div",
      {
        style: {
          display: "inline-block",
          position: "relative",
          top: "3px",
          marginRight: "6px"
        }
      },
      _react2.default.createElement(
        "div",
        { className: "yybuttonAmmn-group" },
        _react2.default.createElement(
          _yylibUi.YYButton,
          {
            className: "yybuttonAmmn",
            icon: icon,
            type: type,
            ghost: ghost,
            visible: this.props.visible,
            disabled: disabled,
            onClick: this.handleShowModal
          },
          buttonText
        ),
        _react2.default.createElement(
          "p",
          { id: titleID, className: dataNull === 0 ? "hidden-title" : "" },
          dataNull
        )
      ),
      _react2.default.createElement(
        _yylibUi.YYModal,
        {
          className: "upload-con",
          title: [_react2.default.createElement(
            _yylibUi.YYButton,
            { className: "title-btn", onClick: this.showModalHM },
            "\u9AD8\u62CD\u4EEA"
          )],
          visible: this.state.visible,
          footer: null,
          onCancel: this.hideModal
        },
        _react2.default.createElement(
          Dragger,
          _extends({}, draggerProps, {
            className: "upload-list-inline",
            multiple: true,
            onPreview: this.handlePreview,
            accept: ""
          }),
          _react2.default.createElement(
            "p",
            { className: "ant-upload-drag-icon" },
            _react2.default.createElement(_antd.Icon, { type: "cloud-upload" })
          ),
          _react2.default.createElement(
            "p",
            { className: "ant-upload-text" },
            "\u70B9\u51FB\u6216\u5C06\u6587\u4EF6\u62D6\u62FD\u5230\u6B64\u533A\u57DF\u4E0A\u4F20"
          ),
          _react2.default.createElement(
            "p",
            { className: "ant-upload-hint" },
            "\u652F\u6301\u4E0A\u4F20\u6587\u4EF6\u5927\u5C0F200MB"
          )
        ),
        _react2.default.createElement(
          "div",
          { className: "upload-list-item" },
          getUploadList ? getUploadList.map(function (item, index) {
            var mapSrc = void 0,
                classNameDom = void 0,
                newName = _this8.fileSuffix(item.fileName),
                spliceSrc = (0, _attachaction.handleUrl)(_urlUpload + "/" + item.filePath + "?filename=" + item.fileName);
            if (newName === "pdf" || newName === "PDF") {
              classNameDom = "icon-pdf";
            } else if (newName === "doc" || newName === "docx") {
              classNameDom = "icon-word";
            } else if (newName === "ppt" || newName === "pptx") {
              classNameDom = "icon-ppt";
            } else if (newName === "xls" || newName === "xlsx") {
              classNameDom = "icon-xls";
            } else if (newName === "rtf") {
              classNameDom = "icon-rtf";
            } else if (newName === "txt") {
              classNameDom = "icon-txt-ext";
            } else {
              classNameDom = "";
            };
            imageTypes.indexOf(newName) > -1 ? mapSrc = _urlUpload + "/" + item.filePath : mapSrc = [require("./file.png")];
            return _react2.default.createElement(
              "div",
              { key: item.gid, className: "load-list" },
              classNameDom === "" ? _react2.default.createElement("img", {
                className: "img-preview",
                title: "\u70B9\u51FB\u9884\u89C8",
                alt: item.fileName,
                src: mapSrc,
                onClick: function onClick() {
                  return _this8.handlePreviewShowModal(index, item.fileName);
                }
              }) : _react2.default.createElement("span", {
                className: "iconfont " + classNameDom,
                title: "\u70B9\u51FB\u9884\u89C8",
                onClick: function onClick() {
                  return _this8.handlePreviewShowModal(index, item.fileName);
                }
              }),
              _react2.default.createElement(
                "a",
                {
                  title: item.fileName,
                  href: spliceSrc,
                  download: item.fileName,
                  onMouseOver: function onMouseOver() {
                    _this8.handleMouseOver(index);
                  },
                  onMouseOut: function onMouseOut() {
                    _this8.handleMouseOut(index, item.fileName);
                  }
                },
                _react2.default.createElement(
                  "div",
                  { className: "file-text-content", ref: "domText" + index },
                  item.fileName
                ),
                _react2.default.createElement(
                  "p",
                  null,
                  _this8.formatFileSize(item.fileSize),
                  "\xA0\xA0",
                  item.createName,
                  "\xA0\xA0",
                  _this8.formatUnixDate(item.createDate)
                )
              ),
              _react2.default.createElement(
                _yylibUi.YYPopconfirm,
                {
                  title: "\u5220\u9664\u540E\u65E0\u6CD5\u6062\u590D\uFF0C\u786E\u5B9A\u8981\u5220\u9664" + item.fileName + "\u5417\uFF1F",
                  onConfirm: function onConfirm() {
                    return _this8.handleDeleteMgr(item.gid, 0);
                  }
                },
                _react2.default.createElement(_antd.Icon, {
                  type: "cross",
                  className: "deleteMgr " + (billState === 0 ? '' : 'isDeleteMgr'),
                  title: "\u5220\u9664\u9644\u4EF6"
                })
              )
            );
          }) : _react2.default.createElement(
            "div",
            null,
            "\u6CA1\u6709\u6587\u4EF6"
          )
        )
      ),
      _react2.default.createElement(
        _yylibUi.YYModal,
        {
          width: "100%",
          className: "high-meter-con",
          style: {
            height: "100%",
            position: "absolute",
            margin: 0,
            top: 0,
            transformOrigin: 0,
            paddingBottom: 0
          },
          title: [_react2.default.createElement(
            "div",
            null,
            _react2.default.createElement(
              "span",
              null,
              "\u9AD8\u62CD\u6444\u5F71\u4EEA\uFF1A"
            ),
            _react2.default.createElement(
              "span",
              { className: "switch-btn" },
              deviceInfo
            )
          )],
          visible: this.state.visibleHM,
          footer: null,
          onCancel: this.hideModalHM
        },
        _react2.default.createElement(
          "div",
          { className: "high-meter-body" },
          _react2.default.createElement(
            "div",
            { className: "high-meter-body-L" },
            _react2.default.createElement(
              "div",
              { className: "high-meter-body-L-title" },
              _react2.default.createElement(
                "span",
                null,
                "\u5DF2\u62CD\u6444"
              ),
              _react2.default.createElement(
                "button",
                { type: "button", onClick: this.deleteHandleFile },
                "\u5220\u9664\u5DF2\u9009(",
                deletedLength,
                ")"
              )
            ),
            _react2.default.createElement(
              "div",
              { className: "high-meter-body-L-album" },
              _react2.default.createElement(
                "div",
                { className: "high-meter-body-L-album-L" },
                _react2.default.createElement(_antd.Icon, {
                  type: "folder-open",
                  className: "icon-caret",
                  style: {
                    position: "absolute",
                    left: "27px",
                    top: "6px",
                    fontSize: "36px"
                  }
                }),
                _react2.default.createElement(_antd.Icon, {
                  type: "caret-right",
                  style: {
                    position: "absolute",
                    left: "85px",
                    top: "29px",
                    fontSize: "12px",
                    transform: "scale(.7)"
                  }
                })
              ),
              _react2.default.createElement(
                "div",
                { className: "high-meter-body-L-album-R" },
                imgPathArray.length ? imgPathArray.map(function (item, index) {
                  return _react2.default.createElement(
                    "div",
                    { key: item, style: { position: "relative" } },
                    _react2.default.createElement("img", { width: "105", height: "85", src: item }),
                    _react2.default.createElement(_antd.Checkbox, {
                      defaultChecked: true,
                      onChange: function onChange(e) {
                        return _this8.handleCheckbox(e, deletePathArray[index], imgPathArray[index]);
                      }
                    })
                  );
                }) : _react2.default.createElement(
                  "div",
                  null,
                  "\u6CA1\u6709\u62CD\u7167"
                )
              )
            )
          ),
          _react2.default.createElement(
            "div",
            { className: "high-meter-body-C" },
            imgVideo === "" ? _react2.default.createElement(
              "div",
              null,
              "\u6CA1\u8FDE\u63A5\u8BBE\u5907\u6216\u6CA1\u5F00\u542F\u9A71\u52A8\uFF0C\u8BF7\u5F00\u542F\u540E\u5237\u65B0\u5C1D\u8BD5"
            ) : _react2.default.createElement("img", { className: "bigPriDev", src: imgVideo })
          ),
          _react2.default.createElement(
            "div",
            { className: "high-meter-body-R" },
            _react2.default.createElement(
              "div",
              { className: "high-meter-body-R-mode" },
              _react2.default.createElement(
                "div",
                { className: "high-meter-body-R-mode-title" },
                "\u62CD\u7167\u6A21\u5F0F\uFF1A"
              ),
              _react2.default.createElement(
                _antd.Radio,
                { checked: true, className: "radio-style", value: 1 },
                "\u5355\u5F20\u62CD\u6444"
              )
            ),
            _react2.default.createElement(
              "div",
              { className: "high-meter-body-R-method" },
              _react2.default.createElement(
                "div",
                { className: "high-meter-body-R-method-title" },
                "\u547D\u540D\u65B9\u5F0F\uFF1A"
              ),
              _react2.default.createElement(
                _antd.Radio,
                { checked: true, className: "radio-style", value: 1 },
                "\u65E5\u671F\u547D\u540D"
              )
            ),
            _react2.default.createElement(
              "div",
              { className: "high-meter-body-R-message" },
              _react2.default.createElement(
                "div",
                null,
                "\u5DF2\u62CD\u6570\u91CF\uFF1A",
                imgPathArray.length
              )
            ),
            _react2.default.createElement(
              "div",
              { className: "high-meter-body-R-action" },
              _react2.default.createElement(
                "button",
                {
                  type: "button",
                  className: "photoBtn",
                  onClick: this.onClickBtn
                },
                "\u5F00\u59CB\u62CD\u6444"
              )
            ),
            _react2.default.createElement(
              "div",
              { className: "high-meter-body-R-upload" },
              _react2.default.createElement(
                _yylibUi.YYButton,
                { onClick: this.handleUpload, type: "button" },
                "\u7ACB\u5373\u4E0A\u4F20"
              )
            )
          )
        )
      ),
      _react2.default.createElement(
        _yylibUi.YYModal,
        {
          title: [_react2.default.createElement(
            "div",
            null,
            _react2.default.createElement(
              "span",
              {
                title: visiblePreview && getUploadList && getUploadList.length ? getUploadList[previewIndex].fileName : ""
              },
              "\u5F53\u524D\u9884\u89C8:\xA0\xA0",
              visiblePreview && getUploadList && getUploadList.length ? getUploadList[previewIndex].fileName : ""
            ),
            _react2.default.createElement(
              "span",
              null,
              "\u5F53\u524D\u4F4D\u7F6E:\xA0\xA0",
              previewIndex + 1 + "/" + dataNull
            )
          )],
          className: "previewModal",
          visible: this.state.visiblePreview,
          footer: null,
          onCancel: this.hideModalPreview
        },
        _react2.default.createElement(
          "div",
          { className: "carousel-container" },
          isToolBar ? _react2.default.createElement(
            "div",
            { className: "toolBar" },
            _react2.default.createElement("span", {
              className: "iconfont icon-revert",
              title: "\u8FD8\u539F",
              onClick: this.handleClickRevert
            }),
            _react2.default.createElement("span", {
              className: "iconfont icon-fangda",
              title: "\u653E\u5927",
              onClick: this.handleClickPlus
            }),
            _react2.default.createElement("span", {
              className: "iconfont icon-suoxiao",
              title: "\u7F29\u5C0F",
              onClick: this.handleClickMinus
            }),
            _react2.default.createElement("span", {
              className: "iconfont icon-xiangzuoxuanzhuan",
              title: "\u5DE6\u65CB\u8F6C",
              onClick: function onClick() {
                return _this8.handleClickRotate(0);
              }
            }),
            _react2.default.createElement("span", {
              className: "iconfont icon-xiangyouxuanzhuan",
              title: "\u53F3\u65CB\u8F6C",
              onClick: function onClick() {
                return _this8.handleClickRotate(1);
              }
            }),
            _react2.default.createElement(
              _yylibUi.YYPopconfirm,
              {
                title: "\u5220\u9664\u540E\u65E0\u6CD5\u6062\u590D\uFF0C\u786E\u5B9A\u8981\u5220\u9664\u5417\uFF1F",
                onConfirm: function onConfirm() {
                  return _this8.handleDeleteMgr(getUploadList[previewIndex].gid, 1);
                }
              },
              _react2.default.createElement("span", {
                className: "iconfont icon-delete " + (billState === 0 ? '' : 'isDelete'),
                title: billState === 0 ? "删除附件" : "删除按钮不可用"
              })
            )
          ) : _react2.default.createElement(
            "div",
            { className: "toolBar" },
            _react2.default.createElement("span", {
              className: "iconfont icon-chakan",
              title: "\u67E5\u770B\u9644\u4EF6",
              onClick: function onClick() {
                return _this8.handleClickPreview(getUploadList[previewIndex]);
              }
            }),
            _react2.default.createElement(
              _yylibUi.YYPopconfirm,
              {
                title: "\u5220\u9664\u540E\u65E0\u6CD5\u6062\u590D\uFF0C\u786E\u5B9A\u8981\u5220\u9664\u5417\uFF1F",
                onConfirm: function onConfirm() {
                  return _this8.handleDeleteMgr(getUploadList[previewIndex].gid, 1);
                }
              },
              _react2.default.createElement("span", {
                className: "iconfont icon-delete " + (billState === 0 ? '' : 'isDelete'),
                title: billState === 0 ? "删除附件" : "删除按钮不可用"
              })
            )
          ),
          _react2.default.createElement(
            "ul",
            { className: "carousel-wrapper" },
            getUploadList ? getUploadList.map(function (item, index) {
              var mapSrc = void 0,
                  classNameDom = void 0,
                  newName = _this8.fileSuffix(item.fileName);
              if (newName === "pdf" || newName === "PDF") {
                classNameDom = "icon-pdf";
              } else if (newName === "doc" || newName === "docx") {
                classNameDom = "icon-word";
              } else if (newName === "ppt" || newName === "pptx") {
                classNameDom = "icon-ppt";
              } else if (newName === "xls" || newName === "xlsx") {
                classNameDom = "icon-xls";
              } else if (newName === "rtf") {
                classNameDom = "icon-rtf";
              } else if (newName === "txt") {
                classNameDom = "icon-txt-ext";
              } else {
                classNameDom = "";
              };
              imageTypes.indexOf(newName) > -1 ? mapSrc = _urlUpload + "/" + item.filePath : mapSrc = [require("./file.png")];
              return index === previewIndex ? _react2.default.createElement(
                "li",
                { key: item.gid, className: "activeted" },
                mapSrc !== _urlUpload + "/" + item.filePath ? _react2.default.createElement(
                  "div",
                  {
                    className: "imgParent",
                    onMouseDown: _this8.handleMouseDown,
                    onMouseUp: _this8.handleMouseUp
                  },
                  classNameDom === "" ? _react2.default.createElement("img", {
                    id: "prevImg" + previewIndex,
                    className: "activeImg",
                    onMouseDown: _this8.stopePreventDefault,
                    alt: item.fileName,
                    src: mapSrc
                  }) : _react2.default.createElement("span", {
                    className: "iconfont " + classNameDom,
                    onClick: _this8.handleClickRevert
                  })
                ) : _react2.default.createElement("img", {
                  id: "prevImg" + previewIndex,
                  className: "activeImgTrue",
                  style: {
                    transform: "rotate(" + imgRoate + "deg)",
                    height: imgHeight + "%"
                  },
                  onMouseDown: _this8.handleMouseDown,
                  onMouseUp: _this8.handleMouseUp,
                  alt: item.fileName,
                  src: mapSrc
                })
              ) : _react2.default.createElement(
                "li",
                { key: item.gid },
                _react2.default.createElement("img", {
                  title: item.fileName,
                  alt: item.fileName,
                  src: mapSrc
                })
              );
            }) : ""
          ),
          _react2.default.createElement(_antd.Icon, {
            type: "left",
            className: "previewBtn btn-prve",
            onClick: this.handlePrePrve
          }),
          _react2.default.createElement(_antd.Icon, {
            type: "right",
            className: "previewBtn btn-next",
            onClick: this.handlePreNext
          })
        )
      )
    );
  }
});
module.exports = AttachMgrModalNew;