'use strict';

/**
 *表体金额汇总赋值表头金额
 * @type {{}}
 */
var NccContext = require('yylib-utils/NccContext');
var money = NccContext.getScales().money;

var NccCalculateBodyFld = {
    /**
     * 汇总计算给定好的表体tableCode页签行的bodyFlds字段的值，到表头的HeadFlds字段
     */
    sumCalculateBodyFldValueByTabCode: function sumCalculateBodyFldValueByTabCode(_ref) {
        var page = _ref.page,
            sumFiled = _ref.sumFiled;

        money = money ? money : NccContext.getScales().money;
        var _sumBody = sumFiled.sumBody ? sumFiled.sumBody : [];
        var _sumHead = sumFiled.sumHead ? sumFiled.sumHead : [];

        _sumBody.map(function (body, index) {
            var _sumMny = 0;

            var _loop = function _loop(bodyTabCode) {
                var _bodyFieldName = body[bodyTabCode];
                var editApi = page.findUI(bodyTabCode).api;
                var _dataS = editApi.getDataSource();
                _dataS.map(function (_data) {

                    //去掉删除项
                    if (_data[_bodyFieldName] && _data['rowState'] !== 'del') {
                        _sumMny = parseFloat(_sumMny) + parseFloat(_data[_bodyFieldName]);
                    }
                });
            };

            for (var bodyTabCode in body) {
                _loop(bodyTabCode);
            }

            //表头赋值
            for (var headTabCode in _sumHead[index]) {
                var _headFieldName = _sumHead[index][headTabCode];
                var formApi = page.findUI(headTabCode).api;
                var _headDta = {};

                _headDta[_headFieldName] = _sumMny ? _.round(_sumMny, money) : _.round(0, money);
                formApi.setFieldsValue(_headDta);
            }
        });
    }
};
module.exports = NccCalculateBodyFld;