'use strict';

/**
 * 跑马灯组件
 */
var React = require('react');
var YYClass = require('../base/YYClass');
var PropTypes = YYClass.PropTypes;
var field = YYClass.field;

var _require = require('antd'),
    Carousel = _require.Carousel;
//定义META


var uiMeta = {
    name: 'carousel',
    fields: [
    //field参数列表：字段属性名|属性默认值|属性类型|是否必填|属性描述
    field('effect', 'scrollx', PropTypes.oneOf(['scrollx', 'fade']), false, '动画效果函数'), field('dots', true, PropTypes.bool, false, '是否显示面板指示点'), field('vertical', false, PropTypes.bool, false, '是否垂直显示'), field('autoplay', false, PropTypes.bool, false, '是否自动切换'), field('easing', 'linear', PropTypes.string, false, '动画效果'), field('beforeChange', null, PropTypes.func, false, '切换面板前的回调'), field('afterChange', null, PropTypes.func, false, '切换面板后的回调')]
};
var YYCarousel = YYClass.create({
    uiMeta: uiMeta,
    render: function render() {
        var cls = this.className();
        return React.createElement(
            'div',
            { className: cls },
            React.createElement(
                Carousel,
                this.props,
                this.props.children
            )
        );
    }
});
module.exports = YYCarousel;