'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

/**
 * 气泡卡片组件
 */
var React = require('react');
var YYClass = require('../base/YYClass');
var PropTypes = YYClass.PropTypes;
var field = YYClass.field;
var CSSUtil = require('../../utils/CSSUtil');

var _require = require('antd'),
    Popover = _require.Popover;

require('./style/index.less');
var uiMeta = {
    name: 'popover',
    fields: [
    //field参数列表：字段属性名|属性默认值|属性类型|是否必填|属性描述
    field('trigger', 'hover', PropTypes.oneOf(['hover', 'click', 'focus']), false, '触发行为'), field('placement', 'top', PropTypes.oneOf(['top', 'left', 'right', 'bottom', 'topLeft', 'topRight', 'bottomLeft', 'bottomRight', 'leftTop', 'leftBottom', 'rightTop', 'rightBottom']), false, '气泡框位置'), field('title', null, PropTypes.element, false, '卡片标题'), field('content', null, PropTypes.element, false, '卡片内容'), field('overlayClassName', undefined, PropTypes.string, false, '卡片类名'), field('overlayStyle', undefined, PropTypes.object, false, '卡片样式'), field('visible', undefined, PropTypes.bool, false, '用于手动控制浮层显隐'), field('onVisibleChange', null, PropTypes.func, false, '显示隐藏改变的回调'), field('getTooltipContainer', null, PropTypes.func, false, '菜单渲染父节点'), field('openClassName', '', PropTypes.string, false, '气泡框展现时触发器添加的类名,可用于打开浮层时高亮触发器')]
};
var YYPopover = YYClass.create({
    uiMeta: uiMeta,
    _getTooltipContainer: function _getTooltipContainer(e) {
        if (typeof this.props.getTooltipContainer == 'function') {
            return this.props.getTooltipContainer(e);
        } else {
            var parentPage = CSSUtil.parent(e, ".yyui-page");
            if (parentPage) {
                return parentPage;
            } else {
                return document.body;
            }
        }
    },
    render: function render() {
        var cls = this.className();
        return React.createElement(
            'div',
            { className: cls },
            React.createElement(
                Popover,
                _extends({}, this.props, { getTooltipContainer: this._getTooltipContainer }),
                this.props.children
            )
        );
    }
});
module.exports = YYPopover;